# Kavach_artifacts

Welcome to the kavach artifacts!

In support of our work:

Aikata Aikata, Andrea Basso, Gaetan Cassiers, Ahmet Can Mert, Sujoy Sinha Roy, *Kavach: Lightweight masking techniques for polynomial arithmetic in lattice-based cryptography*, IACR Trans. Cryptogr. Hardw. Embed. Syst., 2023.

A pre-print of the paper is available at: https://eprint.iacr.org/2023/517

## Getting started

This is the root folder and it contains the following important files and directories: 
- `USAGE.md`: a tutorial on using our scripts
- `HW`: the hardware design files and Vivado scripts.
- `SW`: python scripts for the CW305 board, verifying the hardware functionality, and the collecting the measurements.
- `data`: python scripts processing the side-channel datasets and storage of the datasets.

In each of the three directories, there is a `README.md` file to help you navigate through them.


## Hardware setup

We use ChipWhisperer (cw305) along with Picoscope6000 to collect measurements as shown below. 

<div align="center"><img src="./setup.jpeg"  width="420" height="420"></div>


## Software dependencies

1. `Vivado` (tested on `2019.1` and `2022.2`) (If there is a different version please re-run the hardware bitstream generation).
2. `python3` (tested on `python3.10`), with PyPI packages in `requirements.txt`.

**Note**: Vivado is not needed if you only run analyzes on the datasets we provide.

## Datasets

We provide side-channel datasets, to be downloaded separately from an open-data repository. See `data/README.md`.

## License

Kavach is licensed under the terms of the
GNU GENERAL PUBLIC LICENSE Version 3. See [COPYING](COPYING) and [COPYRIGHT](COPYRIGHT) for more details.

<br />
<br />

_____

<div align="center">Made with :heart: by the Kavach team</div>

_____

