# Kavach artifacts: datasets

Welcome to the `kavach_artifacts/data` folder of the artifacts! 

## Contents

This folder not just contains the measurements but also the files to process them. Thus, it offers more than what its name suggests. Following is a view of the folder contents:

- `t_test.py` is a simple script for running T-tests.
- `trim_traces.py` converts full traces from a raw acquisition (`.mbin` files)
  into separated traces for the two cases of a t-test, keeping only the part of
  interest in the traces.
    + An example or raw trace from our acquisitions is given in
      `raw_measurement_plot.png` (where the two executions that are extracted
      by the trimming script are clearly visible).
    + In our acquisition configuration, raw traces contain two executions, one
      with the fixed key and one with the random key (we reversed the order for half the traces).
      

For a different measurmeent setup the following global variables need to be modified:

In `trim_traces.py`:
- `S_per_C` : This stands for the number of samples per clock-cycle. It is dependent on the clock frequency the design is run at and the timebase.
- `i_per_m` : This stands for the number of iterations per measurement. This value is displayed during measurement collection as the number of range found.


In `t_test.py`:
- `TRACE_LENGTH`: The number of sample in a processed trace

## Downloading the datasets

The datasets can be downloaded from <https://repository.tugraz.at/records/42y5b-wmq11>

The `.zip` file should be extracted such that the following directory tree is built:
```
data/
    kavach_datasets/
        masked/
            setX_YZ.npy
        masked_flawed/
            setX_YZ.npy
```

